Index: uspace/drv/bus/usb/xhci/hw_struct/trb.h
===================================================================
--- uspace/drv/bus/usb/xhci/hw_struct/trb.h	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
+++ uspace/drv/bus/usb/xhci/hw_struct/trb.h	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -0,0 +1,252 @@
+/*
+ * Copyright (c) 2017 Ondrej Hlavaty
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup drvusbxhci
+ * @{
+ */
+/** @file
+ * TRB-related structures of the xHC.
+ *
+ * This file contains all the types of TRB and the TRB ring handling.
+ */
+
+#ifndef XHCI_TRB_H
+#define XHCI_TRB_H
+
+#include "common.h"
+#include <libarch/barrier.h>
+
+/**
+ * TRB types: section 6.4.6, table 139
+ */
+enum xhci_trb_type {
+	XHCI_TRB_TYPE_RESERVED = 0,
+
+// Transfer ring:
+	XHCI_TRB_TYPE_NORMAL,
+	XHCI_TRB_TYPE_SETUP_STAGE,
+	XHCI_TRB_TYPE_DATA_STAGE,
+	XHCI_TRB_TYPE_STATUS_STAGE,
+	XHCI_TRB_TYPE_ISOCH,
+	XHCI_TRB_TYPE_LINK,
+	XHCI_TRB_TYPE_EVENT_DATA,
+	XHCI_TRB_TYPE_NO_OP,
+
+// Command ring:
+	XHCI_TRB_TYPE_ENABLE_SLOT_CMD,
+	XHCI_TRB_TYPE_DISABLE_SLOT_CMD,
+	XHCI_TRB_TYPE_ADDRESS_DEVICE_CMD,
+	XHCI_TRB_TYPE_CONFIGURE_ENDPOINT_CMD,
+	XHCI_TRB_TYPE_EVALUATE_CONTEXT_CMD,
+	XHCI_TRB_TYPE_RESET_ENDPOINT_CMD,
+	XHCI_TRB_TYPE_STOP_ENDPOINT_CMD,
+	XHCI_TRB_TYPE_SET_TR_DEQUEUE_POINTER_CMD,
+	XHCI_TRB_TYPE_RESET_DEVICE_CMD,
+	XHCI_TRB_TYPE_FORCE_EVENT_CMD,
+	XHCI_TRB_TYPE_NEGOTIATE_BANDWIDTH_CMD,
+	XHCI_TRB_TYPE_SET_LATENCY_TOLERANCE_VALUE_CMD,
+	XHCI_TRB_TYPE_GET_PORT_BANDWIDTH_CMD,
+	XHCI_TRB_TYPE_FORCE_HEADER_CMD,
+	XHCI_TRB_TYPE_NO_OP_CMD,
+// Reserved: 24-31
+
+// Event ring:
+	XHCI_TRB_TYPE_TRANSFER_EVENT = 32,
+	XHCI_TRB_TYPE_COMMAND_COMPLETION_EVENT,
+	XHCI_TRB_TYPE_PORT_STATUS_CHANGE_EVENT,
+	XHCI_TRB_TYPE_BANDWIDTH_REQUEST_EVENT,
+	XHCI_TRB_TYPE_DOORBELL_EVENT,
+	XHCI_TRB_TYPE_HOST_CONTROLLER_EVENT,
+	XHCI_TRB_TYPE_DEVICE_NOTIFICATION_EVENT,
+	XHCI_TRB_TYPE_MFINDEX_WRAP_EVENT,
+
+	XHCI_TRB_TYPE_MAX
+};
+
+/**
+ * TRB template: section 4.11.1
+ */
+typedef struct xhci_trb {
+	xhci_qword_t parameter;
+	xhci_dword_t status;
+	xhci_dword_t control;
+} __attribute__((packed)) xhci_trb_t;
+
+#define TRB_TYPE(trb)           XHCI_DWORD_EXTRACT((trb).control, 15, 10)
+#define TRB_CYCLE(trb)          XHCI_DWORD_EXTRACT((trb).control, 0, 0)
+#define TRB_LINK_TC(trb)        XHCI_DWORD_EXTRACT((trb).control, 1, 1)
+#define TRB_IOC(trb)            XHCI_DWORD_EXTRACT((trb).control, 5, 5)
+
+#define TRB_TRANSFER_LENGTH(trb)	XHCI_DWORD_EXTRACT((trb).status, 23, 0)
+#define TRB_COMPLETION_CODE(trb)	XHCI_DWORD_EXTRACT((trb).status, 31, 24)
+
+#define TRB_LINK_SET_TC(trb, val) \
+	xhci_dword_set_bits(&(trb).control, val, 1, 1)
+#define TRB_SET_CYCLE(trb, val) \
+	xhci_dword_set_bits(&(trb).control, val, 0, 0)
+
+#define TRB_CTRL_SET_SETUP_WLENGTH(trb, val) \
+	xhci_qword_set_bits(&(trb).parameter, val, 63, 48)
+#define TRB_CTRL_SET_SETUP_WINDEX(trb, val) \
+	xhci_qword_set_bits(&(trb).parameter, val, 47, 32)
+#define TRB_CTRL_SET_SETUP_WVALUE(trb, val) \
+	xhci_qword_set_bits(&(trb).parameter, val, 31, 16)
+#define TRB_CTRL_SET_SETUP_BREQ(trb, val) \
+	xhci_qword_set_bits(&(trb).parameter, val, 15, 8)
+#define TRB_CTRL_SET_SETUP_BMREQTYPE(trb, val) \
+	xhci_qword_set_bits(&(trb).parameter, val, 7, 0)
+
+#define TRB_CTRL_SET_TD_SIZE(trb, val) \
+	xhci_dword_set_bits(&(trb).status, val, 21, 17)
+#define TRB_CTRL_SET_XFER_LEN(trb, val) \
+	xhci_dword_set_bits(&(trb).status, val, 16, 0)
+
+#define TRB_CTRL_SET_ENT(trb, val) \
+	xhci_dword_set_bits(&(trb).control, val, 1, 1)
+#define TRB_CTRL_SET_ISP(trb, val) \
+	xhci_dword_set_bits(&(trb).control, val, 2, 2)
+#define TRB_CTRL_SET_NS(trb, val) \
+	xhci_dword_set_bits(&(trb).control, val, 3, 3)
+#define TRB_CTRL_SET_CHAIN(trb, val) \
+	xhci_dword_set_bits(&(trb).control, val, 4, 4)
+#define TRB_CTRL_SET_IOC(trb, val) \
+	xhci_dword_set_bits(&(trb).control, val, 5, 5)
+#define TRB_CTRL_SET_IDT(trb, val) \
+	xhci_dword_set_bits(&(trb).control, val, 6, 6)
+
+#define TRB_CTRL_SET_TRB_TYPE(trb, val) \
+	xhci_dword_set_bits(&(trb).control, val, 15, 10)
+#define TRB_CTRL_SET_DIR(trb, val) \
+	xhci_dword_set_bits(&(trb).control, val, 16, 16)
+#define TRB_CTRL_SET_TRT(trb, val) \
+	xhci_dword_set_bits(&(trb).control, val, 17, 16)
+
+/**
+ * The Chain bit is valid only in specific TRB types.
+ */
+static inline bool xhci_trb_is_chained(xhci_trb_t *trb) {
+	const int type = TRB_TYPE(*trb);
+	const bool chain_bit = XHCI_DWORD_EXTRACT(trb->control, 4, 4);
+
+	return chain_bit &&
+	    (type == XHCI_TRB_TYPE_NORMAL
+	    || type == XHCI_TRB_TYPE_DATA_STAGE
+	    || type == XHCI_TRB_TYPE_STATUS_STAGE
+	    || type == XHCI_TRB_TYPE_ISOCH);
+}
+
+static inline void xhci_trb_link_fill(xhci_trb_t *trb, uintptr_t next_phys)
+{
+	// TRBs require 16-byte alignment
+	assert((next_phys & 0xf) == 0);
+
+	xhci_dword_set_bits(&trb->control, XHCI_TRB_TYPE_LINK, 15, 10);
+	xhci_qword_set(&trb->parameter, next_phys);
+}
+
+static inline void xhci_trb_copy_to_pio(xhci_trb_t *dst, xhci_trb_t *src)
+{
+	/*
+	 * As we do not know, whether our architecture is capable of copying 16
+	 * bytes atomically, let's copy the fields one by one.
+	 */
+	dst->parameter = src->parameter;
+	dst->status = src->status;
+
+	write_barrier();
+
+	dst->control = src->control;
+}
+
+static inline void xhci_trb_clean(xhci_trb_t *trb)
+{
+	memset(trb, 0, sizeof(*trb));
+}
+
+/**
+ * Event Ring Segment Table: section 6.5
+ */
+typedef struct xhci_erst_entry {
+	xhci_qword_t rs_base_ptr;       /* 64B aligned */
+	xhci_dword_t size;              /* only low 16 bits, the rest is RsvdZ */
+	xhci_dword_t _reserved;
+} xhci_erst_entry_t;
+
+static inline void xhci_fill_erst_entry(xhci_erst_entry_t *entry, uintptr_t phys, int segments)
+{
+	xhci_qword_set(&entry->rs_base_ptr, phys);
+	xhci_dword_set_bits(&entry->size, segments, 16, 0);
+}
+
+enum xhci_trb_completion_code {
+	XHCI_TRBC_INVALID = 0,
+	XHCI_TRBC_SUCCESS,
+	XHCI_TRBC_DATA_BUFFER_ERROR,
+	XHCI_TRBC_BABBLE_DETECTED_ERROR,
+	XHCI_TRBC_USB_TRANSACTION_ERROR,
+	XHCI_TRBC_TRB_ERROR,
+	XHCI_TRBC_STALL_ERROR,
+	XHCI_TRBC_RESOURCE_ERROR,
+	XHCI_TRBC_BANDWIDTH_ERROR,
+	XHCI_TRBC_NO_SLOTS_ERROR,
+	XHCI_TRBC_INVALID_STREAM_ERROR,
+	XHCI_TRBC_SLOT_NOT_ENABLED_ERROR,
+	XHCI_TRBC_EP_NOT_ENABLED_ERROR,
+	XHCI_TRBC_SHORT_PACKET,
+	XHCI_TRBC_RING_UNDERRUN,
+	XHCI_TRBC_RING_OVERRUN,
+	XHCI_TRBC_VF_EVENT_RING_FULL,
+	XHCI_TRBC_PARAMETER_ERROR,
+	XHCI_TRBC_BANDWIDTH_OVERRUN_ERROR,
+	XHCI_TRBC_CONTEXT_STATE_ERROR,
+	XHCI_TRBC_NO_PING_RESPONSE_ERROR,
+	XHCI_TRBC_EVENT_RING_FULL_ERROR,
+	XHCI_TRBC_INCOMPATIBLE_DEVICE_ERROR,
+	XHCI_TRBC_MISSED_SERVICE_ERROR,
+	XHCI_TRBC_COMMAND_RING_STOPPED,
+	XHCI_TRBC_COMMAND_ABORTED,
+	XHCI_TRBC_STOPPED,
+	XHCI_TRBC_STOPPED_LENGTH_INVALID,
+	XHCI_TRBC_STOPPED_SHORT_PACKET,
+	XHCI_TRBC_MAX_EXIT_LATENCY_TOO_LARGE_ERROR,
+	/* 30 reserved */
+	XHCI_TRBC_ISOCH_BUFFER_OVERRUN = 31,
+	XHCI_TRBC_EVENT_LOST_ERROR,
+	XHCI_TRBC_UNDEFINED_ERROR,
+	XHCI_TRBC_INVALID_STREAM_ID_ERROR,
+	XHCI_TRBC_SECONDARY_BANDWIDTH_ERROR,
+	XHCI_TRBC_SPLIT_TRANSACTION_ERROR,
+	XHCI_TRBC_MAX
+	/**
+	 *  37 - 191 reserved
+	 * 192 - 223 vendor defined error
+	 * 224 - 255 vendor defined info
+	 */
+};
+
+#endif
Index: uspace/drv/bus/usb/xhci/main.c
===================================================================
--- uspace/drv/bus/usb/xhci/main.c	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
+++ uspace/drv/bus/usb/xhci/main.c	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -0,0 +1,206 @@
+/*
+ * Copyright (c) 2017 Ondrej Hlavaty <aearsis@eideo.cz>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup drvusbxhci
+ * @{
+ */
+/** @file
+ * Main routines of XHCI driver.
+ */
+
+#include <ddf/driver.h>
+#include <errno.h>
+#include <io/log.h>
+#include <io/logctl.h>
+#include <usb/debug.h>
+#include <usb/host/ddf_helpers.h>
+
+#include "hc.h"
+#include "rh.h"
+#include "endpoint.h"
+
+#define NAME "xhci"
+
+static int hc_driver_init(hcd_t *, const hw_res_list_parsed_t *, ddf_dev_t *);
+static int hcd_irq_code_gen(irq_code_t *, hcd_t *, const hw_res_list_parsed_t *);
+static int hcd_claim(hcd_t *, ddf_dev_t *);
+static int hcd_start(hcd_t *, bool);
+static int hcd_status(hcd_t *, uint32_t *);
+static void hcd_interrupt(hcd_t *, uint32_t);
+static int hcd_schedule(hcd_t *, usb_transfer_batch_t *);
+static void hc_driver_fini(hcd_t *);
+
+static const ddf_hc_driver_t xhci_ddf_hc_driver = {
+	.name = "XHCI-PCI",
+	.init = hc_driver_init,
+	.irq_code_gen = hcd_irq_code_gen,
+	.claim = hcd_claim,
+	.start = hcd_start,
+	.setup_root_hub = NULL,
+	.fini = hc_driver_fini,
+	.ops = {
+		.schedule       = hcd_schedule,
+		.irq_hook       = hcd_interrupt,
+		.status_hook    = hcd_status,
+	}
+};
+
+static int hc_driver_init(hcd_t *hcd, const hw_res_list_parsed_t *hw_res, ddf_dev_t *device)
+{
+	int err;
+
+	xhci_hc_t *hc = malloc(sizeof(xhci_hc_t));
+	if (!hc)
+		return ENOMEM;
+
+	if ((err = hc_init_mmio(hc, hw_res)))
+		goto err;
+
+	if ((err = hc_init_memory(hc, device)))
+		goto err;
+
+	hcd_set_implementation(hcd, hc, &xhci_ddf_hc_driver.ops, &hc->bus.base);
+	hc->hcd = hcd;
+
+	return EOK;
+err:
+	free(hc);
+	return err;
+}
+
+static int hcd_irq_code_gen(irq_code_t *code, hcd_t *hcd, const hw_res_list_parsed_t *hw_res)
+{
+	xhci_hc_t *hc = hcd_get_driver_data(hcd);
+	assert(hc);
+
+	return hc_irq_code_gen(code, hc, hw_res);
+}
+
+static int hcd_claim(hcd_t *hcd, ddf_dev_t *dev)
+{
+	xhci_hc_t *hc = hcd_get_driver_data(hcd);
+	assert(hc);
+
+	return hc_claim(hc, dev);
+}
+
+static int hcd_start(hcd_t *hcd, bool irq)
+{
+	xhci_hc_t *hc = hcd_get_driver_data(hcd);
+	assert(hc);
+
+	return hc_start(hc, irq);
+}
+
+static int hcd_schedule(hcd_t *hcd, usb_transfer_batch_t *batch)
+{
+	xhci_hc_t *hc = hcd_get_driver_data(hcd);
+	assert(hc);
+
+	return hc_schedule(hc, batch);
+}
+
+static int hcd_status(hcd_t *hcd, uint32_t *status)
+{
+	xhci_hc_t *hc = hcd_get_driver_data(hcd);
+	assert(hc);
+	assert(status);
+
+	return hc_status(hc, status);
+}
+
+static void hcd_interrupt(hcd_t *hcd, uint32_t status)
+{
+	xhci_hc_t *hc = hcd_get_driver_data(hcd);
+	assert(hc);
+
+	hc_interrupt(hc, status);
+}
+
+static void hc_driver_fini(hcd_t *hcd)
+{
+	xhci_hc_t *hc = hcd_get_driver_data(hcd);
+	assert(hc);
+
+	hc_fini(hc);
+
+	free(hc);
+}
+
+/** Initializes a new ddf driver instance of XHCI hcd.
+ *
+ * @param[in] device DDF instance of the device to initialize.
+ * @return Error code.
+ */
+static int xhci_dev_add(ddf_dev_t *device)
+{
+	usb_log_info("Adding device %s", ddf_dev_get_name(device));
+	return hcd_ddf_add_hc(device, &xhci_ddf_hc_driver);
+}
+
+static int xhci_fun_online(ddf_fun_t *fun)
+{
+	return hcd_ddf_device_online(fun);
+}
+
+static int xhci_fun_offline(ddf_fun_t *fun)
+{
+	return hcd_ddf_device_offline(fun);
+}
+
+
+static const driver_ops_t xhci_driver_ops = {
+	.dev_add = xhci_dev_add,
+	.fun_online = xhci_fun_online,
+	.fun_offline = xhci_fun_offline
+};
+
+static const driver_t xhci_driver = {
+	.name = NAME,
+	.driver_ops = &xhci_driver_ops
+};
+
+
+/** Initializes global driver structures (NONE).
+ *
+ * @param[in] argc Nmber of arguments in argv vector (ignored).
+ * @param[in] argv Cmdline argument vector (ignored).
+ * @return Error code.
+ *
+ * Driver debug level is set here.
+ */
+int main(int argc, char *argv[])
+{
+	log_init(NAME);
+	logctl_set_log_level(NAME, LVL_DEBUG2);
+	return ddf_driver_main(&xhci_driver);
+}
+
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/xhci/rh.c
===================================================================
--- uspace/drv/bus/usb/xhci/rh.c	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
+++ uspace/drv/bus/usb/xhci/rh.c	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -0,0 +1,367 @@
+/*
+ * Copyright (c) 2017 Michal Staruch
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup drvusbxhci
+ * @{
+ */
+/** @file
+ * @brief The roothub structures abstraction.
+ */
+
+#include <errno.h>
+#include <str_error.h>
+#include <usb/request.h>
+#include <usb/debug.h>
+#include <usb/host/utils/malloc32.h>
+#include <usb/host/bus.h>
+#include <usb/host/ddf_helpers.h>
+#include <usb/host/hcd.h>
+
+#include "debug.h"
+#include "commands.h"
+#include "endpoint.h"
+#include "hc.h"
+#include "hw_struct/trb.h"
+#include "rh.h"
+#include "transfers.h"
+
+/* This mask only lists registers, which imply port change. */
+static const uint32_t port_change_mask =
+	XHCI_REG_MASK(XHCI_PORT_CSC) |
+	XHCI_REG_MASK(XHCI_PORT_PEC) |
+	XHCI_REG_MASK(XHCI_PORT_WRC) |
+	XHCI_REG_MASK(XHCI_PORT_OCC) |
+	XHCI_REG_MASK(XHCI_PORT_PRC) |
+	XHCI_REG_MASK(XHCI_PORT_PLC) |
+	XHCI_REG_MASK(XHCI_PORT_CEC);
+
+int xhci_rh_init(xhci_rh_t *rh, xhci_hc_t *hc, ddf_dev_t *device)
+{
+	assert(rh);
+	assert(hc);
+
+	rh->hc = hc;
+	rh->max_ports = XHCI_REG_RD(hc->cap_regs, XHCI_CAP_MAX_PORTS);
+	rh->devices_by_port = (xhci_device_t **) calloc(rh->max_ports, sizeof(xhci_device_t *));
+	rh->hc_device = device;
+
+	const int err = device_init(&rh->device.base);
+	if (err)
+		return err;
+
+	/* Initialize route string */
+	rh->device.route_str = 0;
+	rh->device.tier = 0;
+
+	return EOK;
+}
+
+/** Create a device node for device directly connected to RH.
+ */
+static int rh_setup_device(xhci_rh_t *rh, uint8_t port_id)
+{
+	int err;
+	assert(rh);
+	assert(rh->hc_device);
+
+	assert(rh->devices_by_port[port_id - 1] == NULL);
+
+	xhci_bus_t *bus = &rh->hc->bus;
+
+	device_t *dev = hcd_ddf_device_create(rh->hc_device, bus->base.device_size);
+	if (!dev) {
+		usb_log_error("Failed to create USB device function.");
+		return ENOMEM;
+	}
+
+	const xhci_port_speed_t *port_speed = xhci_rh_get_port_speed(rh, port_id);
+	xhci_device_t *xhci_dev = xhci_device_get(dev);
+	xhci_dev->usb3 = port_speed->major == 3;
+	xhci_dev->rh_port = port_id;
+
+	dev->hub = &rh->device.base;
+	dev->port = port_id;
+	dev->speed = port_speed->usb_speed;
+
+	if ((err = xhci_bus_enumerate_device(bus, rh->hc, dev))) {
+		usb_log_error("Failed to enumerate USB device: %s", str_error(err));
+		return err;
+	}
+
+	if (!ddf_fun_get_name(dev->fun)) {
+		device_set_default_name(dev);
+	}
+
+	if ((err = ddf_fun_bind(dev->fun))) {
+		usb_log_error("Failed to register device " XHCI_DEV_FMT " DDF function: %s.",
+		    XHCI_DEV_ARGS(*xhci_dev), str_error(err));
+		goto err_usb_dev;
+	}
+
+	fibril_mutex_lock(&rh->device.base.guard);
+	list_append(&dev->link, &rh->device.base.devices);
+	rh->devices_by_port[port_id - 1] = xhci_dev;
+	fibril_mutex_unlock(&rh->device.base.guard);
+
+	return EOK;
+
+err_usb_dev:
+	hcd_ddf_device_destroy(dev);
+	return err;
+}
+
+static int handle_connected_device(xhci_rh_t *rh, uint8_t port_id)
+{
+	xhci_port_regs_t *regs = &rh->hc->op_regs->portrs[port_id - 1];
+
+	uint8_t link_state = XHCI_REG_RD(regs, XHCI_PORT_PLS);
+	const xhci_port_speed_t *speed = xhci_rh_get_port_speed(rh, port_id);
+
+	usb_log_info("Detected new %.4s%u.%u device on port %u.", speed->name, speed->major, speed->minor, port_id);
+
+	if (speed->major == 3) {
+		if (link_state == 0) {
+			/* USB3 is automatically advanced to enabled. */
+			return rh_setup_device(rh, port_id);
+		}
+		else if (link_state == 5) {
+			/* USB 3 failed to enable. */
+			usb_log_error("USB 3 port couldn't be enabled.");
+			return EAGAIN;
+		}
+		else {
+			usb_log_error("USB 3 port is in invalid state %u.", link_state);
+			return EINVAL;
+		}
+	}
+	else {
+		usb_log_debug("USB 2 device attached, issuing reset.");
+		xhci_rh_reset_port(rh, port_id);
+		/*
+			FIXME: we need to wait for the event triggered by the reset
+			and then alloc_dev()... can't it be done directly instead of
+			going around?
+		*/
+		return EOK;
+	}
+}
+
+/** Deal with a detached device.
+ */
+static int handle_disconnected_device(xhci_rh_t *rh, uint8_t port_id)
+{
+	assert(rh);
+	int err;
+
+	/* Find XHCI device by the port. */
+	xhci_device_t *dev = rh->devices_by_port[port_id - 1];
+	if (!dev) {
+		/* Must be extraneous call. */
+		return EOK;
+	}
+
+	usb_log_info("Device " XHCI_DEV_FMT " at port %u has been disconnected.",
+	    XHCI_DEV_ARGS(*dev), port_id);
+
+	/* Mark the device as detached. */
+	fibril_mutex_lock(&rh->device.base.guard);
+	list_remove(&dev->base.link);
+	rh->devices_by_port[port_id - 1] = NULL;
+	fibril_mutex_unlock(&rh->device.base.guard);
+
+	/* Remove device from XHCI bus. */
+	if ((err = xhci_bus_remove_device(&rh->hc->bus, rh->hc, &dev->base))) {
+		usb_log_warning("Failed to remove device " XHCI_DEV_FMT " from XHCI bus: %s",
+		    XHCI_DEV_ARGS(*dev), str_error(err));
+	}
+
+	return EOK;
+}
+
+/** Handle an incoming Port Change Detected Event.
+ */
+int xhci_rh_handle_port_status_change_event(xhci_hc_t *hc, xhci_trb_t *trb)
+{
+	uint8_t port_id = XHCI_QWORD_EXTRACT(trb->parameter, 31, 24);
+	usb_log_debug("Port status change event detected for port %u.", port_id);
+
+	/**
+	 * We can't be sure that the port change this event announces is the
+	 * only port change that happened (see section 4.19.2 of the xHCI
+	 * specification). Therefore, we just check all ports for changes.
+	 */
+	xhci_rh_handle_port_change(&hc->rh);
+
+	return EOK;
+}
+
+void xhci_rh_handle_port_change(xhci_rh_t *rh)
+{
+	for (uint8_t i = 1; i <= rh->max_ports; ++i) {
+		xhci_port_regs_t *regs = &rh->hc->op_regs->portrs[i - 1];
+
+		uint32_t events = XHCI_REG_RD_FIELD(&regs->portsc, 32);
+		XHCI_REG_WR_FIELD(&regs->portsc, events, 32);
+
+		events &= port_change_mask;
+
+		if (events & XHCI_REG_MASK(XHCI_PORT_CSC)) {
+			usb_log_info("Connected state changed on port %u.", i);
+			events &= ~XHCI_REG_MASK(XHCI_PORT_CSC);
+
+			bool connected = XHCI_REG_RD(regs, XHCI_PORT_CCS);
+			if (connected) {
+				handle_connected_device(rh, i);
+			} else {
+				handle_disconnected_device(rh, i);
+			}
+		}
+
+		if (events & XHCI_REG_MASK(XHCI_PORT_PEC)) {
+			usb_log_info("Port enabled changed on port %u.", i);
+			events &= ~XHCI_REG_MASK(XHCI_PORT_PEC);
+		}
+
+		if (events & XHCI_REG_MASK(XHCI_PORT_WRC)) {
+			usb_log_info("Warm port reset on port %u completed.", i);
+			events &= ~XHCI_REG_MASK(XHCI_PORT_WRC);
+		}
+
+		if (events & XHCI_REG_MASK(XHCI_PORT_OCC)) {
+			usb_log_info("Over-current change on port %u.", i);
+			events &= ~XHCI_REG_MASK(XHCI_PORT_OCC);
+		}
+
+		if (events & XHCI_REG_MASK(XHCI_PORT_PRC)) {
+			usb_log_info("Port reset on port %u completed.", i);
+			events &= ~XHCI_REG_MASK(XHCI_PORT_PRC);
+
+			const xhci_port_speed_t *speed = xhci_rh_get_port_speed(rh, i);
+			if (speed->major != 3) {
+				/* FIXME: We probably don't want to do this
+				 * every time USB2 port is reset. This is a
+				 * temporary workaround. */
+				rh_setup_device(rh, i);
+			}
+		}
+
+		if (events & XHCI_REG_MASK(XHCI_PORT_PLC)) {
+			usb_log_info("Port link state changed on port %u.", i);
+			events &= ~XHCI_REG_MASK(XHCI_PORT_PLC);
+		}
+
+		if (events & XHCI_REG_MASK(XHCI_PORT_CEC)) {
+			usb_log_info("Port %u failed to configure link.", i);
+			events &= ~XHCI_REG_MASK(XHCI_PORT_CEC);
+		}
+
+		if (events) {
+			usb_log_warning("Port change (0x%08x) ignored on port %u.", events, i);
+		}
+	}
+
+	/**
+	 * Theory:
+	 *
+	 * Although more events could have happened while processing, the PCD
+	 * bit in USBSTS will be set on every change. Because the PCD is
+	 * cleared even before the interrupt is cleared, it is safe to assume
+	 * that this handler will be called again.
+	 *
+	 * But because we could have handled the event in previous run of this
+	 * handler, it is not an error when no event is detected.
+	 *
+	 * Reality:
+	 *
+	 * The PCD bit is never set. TODO Check why the interrupt never carries
+	 * the PCD flag. Possibly repeat the checking until we're sure the
+	 * PSCEG is 0 - check section 4.19.2 of the xHCI spec.
+	 */
+}
+
+static inline int get_hub_available_bandwidth(xhci_hc_t *hc, xhci_device_t* dev, uint8_t speed, xhci_port_bandwidth_ctx_t *ctx) {
+	// TODO: find a correct place for this function + API
+	// We need speed, because a root hub device has both USB 2 and USB 3 speeds
+	// and the command can query only one of them
+	// ctx is an out parameter as of now
+	assert(dev);
+	assert(ctx);
+
+	xhci_port_bandwidth_ctx_t *in_ctx = malloc32(sizeof(xhci_port_bandwidth_ctx_t));
+	if (!in_ctx) {
+		return ENOMEM;
+	}
+
+	xhci_cmd_t cmd;
+	xhci_cmd_init(&cmd, XHCI_CMD_GET_PORT_BANDWIDTH);
+
+	cmd.bandwidth_ctx = in_ctx;
+	cmd.device_speed = speed;
+
+	int err;
+	if ((err = xhci_cmd_sync(hc, &cmd))) {
+		goto end;
+	}
+
+	memcpy(ctx, in_ctx, sizeof(xhci_port_bandwidth_ctx_t));
+
+end:
+	xhci_cmd_fini(&cmd);
+	return EOK;
+}
+
+const xhci_port_speed_t *xhci_rh_get_port_speed(xhci_rh_t *rh, uint8_t port)
+{
+	xhci_port_regs_t *port_regs = &rh->hc->op_regs->portrs[port - 1];
+
+	unsigned psiv = XHCI_REG_RD(port_regs, XHCI_PORT_PS);
+	return &rh->hc->speeds[psiv];
+}
+
+int xhci_rh_reset_port(xhci_rh_t* rh, uint8_t port)
+{
+	usb_log_debug2("Resetting port %u.", port);
+	xhci_port_regs_t *regs = &rh->hc->op_regs->portrs[port-1];
+	XHCI_REG_SET(regs, XHCI_PORT_PR, 1);
+
+	return EOK;
+}
+
+int xhci_rh_fini(xhci_rh_t *rh)
+{
+	/* TODO: Implement me! */
+	usb_log_debug2("Called xhci_rh_fini().");
+
+	free(rh->devices_by_port);
+
+	return EOK;
+}
+
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/xhci/rh.h
===================================================================
--- uspace/drv/bus/usb/xhci/rh.h	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
+++ uspace/drv/bus/usb/xhci/rh.h	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -0,0 +1,96 @@
+/*
+ * Copyright (c) 2017 Michal Staruch
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup drvusbxhci
+ * @{
+ */
+/** @file
+ * @brief The roothub structures abstraction.
+ */
+
+#ifndef XHCI_RH_H
+#define XHCI_RH_H
+
+#include <usb/host/usb_transfer_batch.h>
+#include <usb/host/bus.h>
+
+#include "hw_struct/regs.h"
+#include "endpoint.h"
+
+typedef struct xhci_hc xhci_hc_t;
+typedef struct ddf_dev ddf_dev_t;
+
+/**
+ * xHCI lets the controller define speeds of ports it controls.
+ */
+typedef struct xhci_port_speed {
+	char name [4];
+	uint8_t major, minor;
+	uint64_t rx_bps, tx_bps;
+	usb_speed_t usb_speed;
+} xhci_port_speed_t;
+
+typedef struct hcd_roothub hcd_roothub_t;
+typedef struct xhci_bus xhci_bus_t;
+
+/* XHCI root hub instance */
+typedef struct {
+	/** Host controller */
+	xhci_hc_t *hc;
+
+	/* Root for the device tree */
+	xhci_device_t device;
+
+	/* We need this to attach children to */
+	ddf_dev_t *hc_device;
+
+	/** Interrupt transfer waiting for an actual interrupt to occur */
+	usb_transfer_batch_t *unfinished_interrupt_transfer;
+
+	/* Number of hub ports. */
+	uint8_t max_ports;
+
+	/* Device pointers connected to RH ports or NULL. (size is `max_ports`) */
+	xhci_device_t **devices_by_port;
+} xhci_rh_t;
+
+int xhci_rh_init(xhci_rh_t *, xhci_hc_t *, ddf_dev_t *);
+int xhci_rh_fini(xhci_rh_t *);
+const xhci_port_speed_t *xhci_rh_get_port_speed(xhci_rh_t *, uint8_t);
+int xhci_rh_reset_port(xhci_rh_t *, uint8_t);
+
+int xhci_rh_handle_port_status_change_event(xhci_hc_t *, xhci_trb_t *);
+void xhci_rh_handle_port_change(xhci_rh_t *);
+
+int xhci_rh_address_device(xhci_rh_t *rh, device_t *dev, xhci_bus_t *bus);
+
+#endif
+
+/**
+ * @}
+ */
